import { OnInit, EventEmitter } from '@angular/core';
export declare class EasyDndUploadComponent implements OnInit {
    files: any[];
    /*************************************************************
     * Input() memebrs
     *************************************************************/
    private _title;
    set title(value: string);
    get title(): string;
    private _allowedFiles;
    set allowedFiles(value: string);
    get allowedFiles(): string;
    private _fileLimit;
    set fileLimit(value: number);
    get fileLimit(): number;
    private _allowMultiple;
    set allowMultiple(value: boolean);
    get allowMultiple(): boolean;
    droppedFiles: EventEmitter<any>;
    constructor();
    ngOnInit(): void;
    /**
     * on file drop handler
     */
    onFileDropped($event: any): void;
    /**
     * handle file from browsing
     */
    fileBrowseHandler(files: any): void;
    /**
     * Delete file from files list
     * @param index (File index)
     */
    deleteFile(index: number): void;
    /**
     * Simulate the upload process
     */
    uploadFilesSimulator(index: number): void;
    /**
     * Convert Files list to normal array list
     * @param files (Files List)
     */
    prepareFilesList(files: Array<any>): void;
    /**
     * format bytes
     * @param bytes (File size in bytes)
     * @param decimals (Decimals point)
     */
    formatBytes(bytes: any, decimals: any): string;
}
